import{s as Pe,n as Ee,o as Le}from"../chunks/scheduler.8c3d61f6.js";import{S as Oe,i as Me,g as a,s as r,r as l,A as Ne,h as d,f as t,c as i,j as S,u as p,x as D,k as T,y as s,a as u,v as m,d as f,t as h,w as g}from"../chunks/index.da70eac4.js";import{D as K}from"../chunks/Docstring.6b390b9a.js";import{H as ve,E as ke}from"../chunks/EditOnGithub.1e64e623.js";function Ie($e){let _,R,F,W,H,J,w,xe='The Heun scheduler (Algorithm 1) is from the <a href="https://huggingface.co/papers/2206.00364" rel="nofollow">Elucidating the Design Space of Diffusion-Based Generative Models</a> paper by Karras et al. The scheduler is ported from the <a href="https://github.com/crowsonkb/k-diffusion" rel="nofollow">k-diffusion</a> library and created by <a href="https://github.com/crowsonkb/" rel="nofollow">Katherine Crowson</a>.',Q,C,X,o,P,de,q,ye="Scheduler with Heun steps for discrete beta schedules.",ce,U,Se=`This model inherits from <a href="/docs/diffusers/pr_10146/en/api/schedulers/overview#diffusers.SchedulerMixin">SchedulerMixin</a> and <a href="/docs/diffusers/pr_10146/en/api/configuration#diffusers.ConfigMixin">ConfigMixin</a>. Check the superclass documentation for the generic
methods the library implements for all schedulers such as loading and saving.`,ue,v,E,le,V,De=`Ensures interchangeability with schedulers that need to scale the denoising model input depending on the
current timestep.`,pe,$,L,me,A,Te="Sets the begin index for the scheduler. This function should be run from pipeline before the inference.",fe,x,O,he,j,He="Sets the discrete timesteps used for the diffusion chain (to be run before inference).",ge,y,M,_e,z,we=`Predict the sample from the previous timestep by reversing the SDE. This function propagates the diffusion
process from the learned model outputs (most often the predicted noise).`,Y,N,Z,b,k,be,B,Ce="Base class for the output of a scheduler’s <code>step</code> function.",ee,I,te,G,se;return H=new ve({props:{title:"HeunDiscreteScheduler",local:"heundiscretescheduler",headingTag:"h1"}}),C=new ve({props:{title:"HeunDiscreteScheduler",local:"diffusers.HeunDiscreteScheduler",headingTag:"h2"}}),P=new K({props:{name:"class diffusers.HeunDiscreteScheduler",anchor:"diffusers.HeunDiscreteScheduler",parameters:[{name:"num_train_timesteps",val:": int = 1000"},{name:"beta_start",val:": float = 0.00085"},{name:"beta_end",val:": float = 0.012"},{name:"beta_schedule",val:": str = 'linear'"},{name:"trained_betas",val:": typing.Union[numpy.ndarray, typing.List[float], NoneType] = None"},{name:"prediction_type",val:": str = 'epsilon'"},{name:"sigma_schedule",val:": typing.Union[diffusers.schedulers.sigmas.beta_sigmas.BetaSigmas, diffusers.schedulers.sigmas.exponential_sigmas.ExponentialSigmas, diffusers.schedulers.sigmas.karras_sigmas.KarrasSigmas, NoneType] = None"},{name:"clip_sample",val:": typing.Optional[bool] = False"},{name:"clip_sample_range",val:": float = 1.0"},{name:"timestep_spacing",val:": str = 'linspace'"},{name:"steps_offset",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, defaults to 1000) &#x2014;
The number of diffusion steps to train the model.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.beta_start",description:`<strong>beta_start</strong> (<code>float</code>, defaults to 0.0001) &#x2014;
The starting <code>beta</code> value of inference.`,name:"beta_start"},{anchor:"diffusers.HeunDiscreteScheduler.beta_end",description:`<strong>beta_end</strong> (<code>float</code>, defaults to 0.02) &#x2014;
The final <code>beta</code> value.`,name:"beta_end"},{anchor:"diffusers.HeunDiscreteScheduler.beta_schedule",description:`<strong>beta_schedule</strong> (<code>str</code>, defaults to <code>&quot;linear&quot;</code>) &#x2014;
The beta schedule, a mapping from a beta range to a sequence of betas for stepping the model. Choose from
<code>linear</code> or <code>scaled_linear</code>.`,name:"beta_schedule"},{anchor:"diffusers.HeunDiscreteScheduler.trained_betas",description:`<strong>trained_betas</strong> (<code>np.ndarray</code>, <em>optional</em>) &#x2014;
Pass an array of betas directly to the constructor to bypass <code>beta_start</code> and <code>beta_end</code>.`,name:"trained_betas"},{anchor:"diffusers.HeunDiscreteScheduler.prediction_type",description:`<strong>prediction_type</strong> (<code>str</code>, defaults to <code>epsilon</code>, <em>optional</em>) &#x2014;
Prediction type of the scheduler function; can be <code>epsilon</code> (predicts the noise of the diffusion process),
<code>sample</code> (directly predicts the noisy sample<code>) or </code>v_prediction\` (see section 2.4 of <a href="https://imagen.research.google/video/paper.pdf" rel="nofollow">Imagen
Video</a> paper).`,name:"prediction_type"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample",description:`<strong>clip_sample</strong> (<code>bool</code>, defaults to <code>True</code>) &#x2014;
Clip the predicted sample for numerical stability.`,name:"clip_sample"},{anchor:"diffusers.HeunDiscreteScheduler.clip_sample_range",description:`<strong>clip_sample_range</strong> (<code>float</code>, defaults to 1.0) &#x2014;
The maximum magnitude for sample clipping. Valid only when <code>clip_sample=True</code>.`,name:"clip_sample_range"},{anchor:"diffusers.HeunDiscreteScheduler.timestep_spacing",description:`<strong>timestep_spacing</strong> (<code>str</code>, defaults to <code>&quot;linspace&quot;</code>) &#x2014;
The way the timesteps should be scaled. Refer to Table 2 of the <a href="https://huggingface.co/papers/2305.08891" rel="nofollow">Common Diffusion Noise Schedules and
Sample Steps are Flawed</a> for more information.`,name:"timestep_spacing"},{anchor:"diffusers.HeunDiscreteScheduler.steps_offset",description:`<strong>steps_offset</strong> (<code>int</code>, defaults to 0) &#x2014;
An offset added to the inference steps, as required by some model families.`,name:"steps_offset"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_heun_discrete.py#L92"}}),E=new K({props:{name:"scale_model_input",anchor:"diffusers.HeunDiscreteScheduler.scale_model_input",parameters:[{name:"sample",val:": Tensor"},{name:"timestep",val:": typing.Union[float, torch.Tensor]"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
The input sample.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.scale_model_input.timestep",description:`<strong>timestep</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The current timestep in the diffusion chain.`,name:"timestep"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_heun_discrete.py#L222",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>A scaled input sample.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>torch.Tensor</code></p>
`}}),L=new K({props:{name:"set_begin_index",anchor:"diffusers.HeunDiscreteScheduler.set_begin_index",parameters:[{name:"begin_index",val:": int = 0"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_begin_index.begin_index",description:`<strong>begin_index</strong> (<code>int</code>) &#x2014;
The begin index for the scheduler.`,name:"begin_index"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_heun_discrete.py#L212"}}),O=new K({props:{name:"set_timesteps",anchor:"diffusers.HeunDiscreteScheduler.set_timesteps",parameters:[{name:"num_inference_steps",val:": typing.Optional[int] = None"},{name:"device",val:": typing.Union[str, torch.device] = None"},{name:"num_train_timesteps",val:": typing.Optional[int] = None"},{name:"timesteps",val:": typing.Optional[typing.List[int]] = None"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_inference_steps",description:`<strong>num_inference_steps</strong> (<code>int</code>) &#x2014;
The number of diffusion steps used when generating samples with a pre-trained model.`,name:"num_inference_steps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.device",description:`<strong>device</strong> (<code>str</code> or <code>torch.device</code>, <em>optional</em>) &#x2014;
The device to which the timesteps should be moved to. If <code>None</code>, the timesteps are not moved.`,name:"device"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.num_train_timesteps",description:`<strong>num_train_timesteps</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The number of diffusion steps used when training the model. If <code>None</code>, the default
<code>num_train_timesteps</code> attribute is used.`,name:"num_train_timesteps"},{anchor:"diffusers.HeunDiscreteScheduler.set_timesteps.timesteps",description:`<strong>timesteps</strong> (<code>List[int]</code>, <em>optional</em>) &#x2014;
Custom timesteps used to support arbitrary spacing between timesteps. If <code>None</code>, timesteps will be
generated based on the <code>timestep_spacing</code> attribute. If <code>timesteps</code> is passed, <code>num_inference_steps</code>
must be <code>None</code>, and <code>timestep_spacing</code> attribute will be ignored.`,name:"timesteps"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_heun_discrete.py#L248"}}),M=new K({props:{name:"step",anchor:"diffusers.HeunDiscreteScheduler.step",parameters:[{name:"model_output",val:": typing.Union[torch.Tensor, numpy.ndarray]"},{name:"timestep",val:": typing.Union[float, torch.Tensor]"},{name:"sample",val:": typing.Union[torch.Tensor, numpy.ndarray]"},{name:"return_dict",val:": bool = True"}],parametersDescription:[{anchor:"diffusers.HeunDiscreteScheduler.step.model_output",description:`<strong>model_output</strong> (<code>torch.Tensor</code>) &#x2014;
The direct output from learned diffusion model.`,name:"model_output"},{anchor:"diffusers.HeunDiscreteScheduler.step.timestep",description:`<strong>timestep</strong> (<code>float</code>) &#x2014;
The current discrete timestep in the diffusion chain.`,name:"timestep"},{anchor:"diffusers.HeunDiscreteScheduler.step.sample",description:`<strong>sample</strong> (<code>torch.Tensor</code>) &#x2014;
A current instance of a sample created by the diffusion process.`,name:"sample"},{anchor:"diffusers.HeunDiscreteScheduler.step.return_dict",description:`<strong>return_dict</strong> (<code>bool</code>) &#x2014;
Whether or not to return a <code>HeunDiscreteSchedulerOutput</code> or
tuple.`,name:"return_dict"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_heun_discrete.py#L367",returnDescription:`<script context="module">export const metadata = 'undefined';<\/script>


<p>If return_dict is <code>True</code>, <code>HeunDiscreteSchedulerOutput</code> is
returned, otherwise a tuple is returned where the first element is the sample tensor.</p>
`,returnType:`<script context="module">export const metadata = 'undefined';<\/script>


<p><code>HeunDiscreteSchedulerOutput</code> or <code>tuple</code></p>
`}}),N=new ve({props:{title:"SchedulerOutput",local:"diffusers.schedulers.scheduling_utils.SchedulerOutput",headingTag:"h2"}}),k=new K({props:{name:"class diffusers.schedulers.scheduling_utils.SchedulerOutput",anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput",parameters:[{name:"prev_sample",val:": Tensor"}],parametersDescription:[{anchor:"diffusers.schedulers.scheduling_utils.SchedulerOutput.prev_sample",description:`<strong>prev_sample</strong> (<code>torch.Tensor</code> of shape <code>(batch_size, num_channels, height, width)</code> for images) &#x2014;
Computed sample <code>(x_{t-1})</code> of previous timestep. <code>prev_sample</code> should be used as next model input in the
denoising loop.`,name:"prev_sample"}],source:"https://github.com/huggingface/diffusers/blob/vr_10146/src/diffusers/schedulers/scheduling_utils.py#L60"}}),I=new ke({props:{source:"https://github.com/huggingface/diffusers/blob/main/docs/source/en/api/schedulers/heun.md"}}),{c(){_=a("meta"),R=r(),F=a("p"),W=r(),l(H.$$.fragment),J=r(),w=a("p"),w.innerHTML=xe,Q=r(),l(C.$$.fragment),X=r(),o=a("div"),l(P.$$.fragment),de=r(),q=a("p"),q.textContent=ye,ce=r(),U=a("p"),U.innerHTML=Se,ue=r(),v=a("div"),l(E.$$.fragment),le=r(),V=a("p"),V.textContent=De,pe=r(),$=a("div"),l(L.$$.fragment),me=r(),A=a("p"),A.textContent=Te,fe=r(),x=a("div"),l(O.$$.fragment),he=r(),j=a("p"),j.textContent=He,ge=r(),y=a("div"),l(M.$$.fragment),_e=r(),z=a("p"),z.textContent=we,Y=r(),l(N.$$.fragment),Z=r(),b=a("div"),l(k.$$.fragment),be=r(),B=a("p"),B.innerHTML=Ce,ee=r(),l(I.$$.fragment),te=r(),G=a("p"),this.h()},l(e){const n=Ne("svelte-u9bgzb",document.head);_=d(n,"META",{name:!0,content:!0}),n.forEach(t),R=i(e),F=d(e,"P",{}),S(F).forEach(t),W=i(e),p(H.$$.fragment,e),J=i(e),w=d(e,"P",{"data-svelte-h":!0}),D(w)!=="svelte-1r9m54f"&&(w.innerHTML=xe),Q=i(e),p(C.$$.fragment,e),X=i(e),o=d(e,"DIV",{class:!0});var c=S(o);p(P.$$.fragment,c),de=i(c),q=d(c,"P",{"data-svelte-h":!0}),D(q)!=="svelte-1k165jq"&&(q.textContent=ye),ce=i(c),U=d(c,"P",{"data-svelte-h":!0}),D(U)!=="svelte-sejf19"&&(U.innerHTML=Se),ue=i(c),v=d(c,"DIV",{class:!0});var ne=S(v);p(E.$$.fragment,ne),le=i(ne),V=d(ne,"P",{"data-svelte-h":!0}),D(V)!=="svelte-1rkfgpx"&&(V.textContent=De),ne.forEach(t),pe=i(c),$=d(c,"DIV",{class:!0});var re=S($);p(L.$$.fragment,re),me=i(re),A=d(re,"P",{"data-svelte-h":!0}),D(A)!=="svelte-1k141rk"&&(A.textContent=Te),re.forEach(t),fe=i(c),x=d(c,"DIV",{class:!0});var ie=S(x);p(O.$$.fragment,ie),he=i(ie),j=d(ie,"P",{"data-svelte-h":!0}),D(j)!=="svelte-1vzm9q"&&(j.textContent=He),ie.forEach(t),ge=i(c),y=d(c,"DIV",{class:!0});var oe=S(y);p(M.$$.fragment,oe),_e=i(oe),z=d(oe,"P",{"data-svelte-h":!0}),D(z)!=="svelte-hi84tp"&&(z.textContent=we),oe.forEach(t),c.forEach(t),Y=i(e),p(N.$$.fragment,e),Z=i(e),b=d(e,"DIV",{class:!0});var ae=S(b);p(k.$$.fragment,ae),be=i(ae),B=d(ae,"P",{"data-svelte-h":!0}),D(B)!=="svelte-6ojmkw"&&(B.innerHTML=Ce),ae.forEach(t),ee=i(e),p(I.$$.fragment,e),te=i(e),G=d(e,"P",{}),S(G).forEach(t),this.h()},h(){T(_,"name","hf:doc:metadata"),T(_,"content",qe),T(v,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T($,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(y,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(o,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(b,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(e,n){s(document.head,_),u(e,R,n),u(e,F,n),u(e,W,n),m(H,e,n),u(e,J,n),u(e,w,n),u(e,Q,n),m(C,e,n),u(e,X,n),u(e,o,n),m(P,o,null),s(o,de),s(o,q),s(o,ce),s(o,U),s(o,ue),s(o,v),m(E,v,null),s(v,le),s(v,V),s(o,pe),s(o,$),m(L,$,null),s($,me),s($,A),s(o,fe),s(o,x),m(O,x,null),s(x,he),s(x,j),s(o,ge),s(o,y),m(M,y,null),s(y,_e),s(y,z),u(e,Y,n),m(N,e,n),u(e,Z,n),u(e,b,n),m(k,b,null),s(b,be),s(b,B),u(e,ee,n),m(I,e,n),u(e,te,n),u(e,G,n),se=!0},p:Ee,i(e){se||(f(H.$$.fragment,e),f(C.$$.fragment,e),f(P.$$.fragment,e),f(E.$$.fragment,e),f(L.$$.fragment,e),f(O.$$.fragment,e),f(M.$$.fragment,e),f(N.$$.fragment,e),f(k.$$.fragment,e),f(I.$$.fragment,e),se=!0)},o(e){h(H.$$.fragment,e),h(C.$$.fragment,e),h(P.$$.fragment,e),h(E.$$.fragment,e),h(L.$$.fragment,e),h(O.$$.fragment,e),h(M.$$.fragment,e),h(N.$$.fragment,e),h(k.$$.fragment,e),h(I.$$.fragment,e),se=!1},d(e){e&&(t(R),t(F),t(W),t(J),t(w),t(Q),t(X),t(o),t(Y),t(Z),t(b),t(ee),t(te),t(G)),t(_),g(H,e),g(C,e),g(P),g(E),g(L),g(O),g(M),g(N,e),g(k),g(I,e)}}}const qe='{"title":"HeunDiscreteScheduler","local":"heundiscretescheduler","sections":[{"title":"HeunDiscreteScheduler","local":"diffusers.HeunDiscreteScheduler","sections":[],"depth":2},{"title":"SchedulerOutput","local":"diffusers.schedulers.scheduling_utils.SchedulerOutput","sections":[],"depth":2}],"depth":1}';function Ue($e){return Le(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class Be extends Oe{constructor(_){super(),Me(this,_,Ue,Ie,Pe,{})}}export{Be as component};
